/***************************************************************************
                          cost.cpp  -  description
                             -------------------

    functionality        : for computing MDL-related measures
    relevant classes     : vindex, tindex
    relevant functions   : compute_cost, calcula_partv

    begin                : 20 oct 2001
    copyright            : (C) 2001 by Cesar Ferri, Jose Hernandez
    email                : {cferri,jorallo}@dsic.upv.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cost.h"	
/*calcula en bits 	el coste de la tabla*/
#define COST_REAL 32
// #define DEBUG_COST
// calcula es cost de la seguent forma
// cost = n exemples + cost taula +cost exemples
// cost taula= sum (para cada argument) n valos eixe cas* log(valors taula original)
// cost exemples= num exemple* log (valors de eixe cas)

double compute_cost(const dataset &dt,const tindex  & ttaula,const exetablet   & itaula,int nej)
{
	/*  float faux,log2,log3;*/
	  unsigned int a,b,i;
	  double faux=0,cost_ejem,faux1=0;

  /*por cada uno de los parametros*/
  for (i=0;i<ttaula.size();i++)
    {
    if (dt.KindOf(i)==DISCRETE_KIND)
    {
    		a=ttaula[i].cant; // quantitat en este cas
     	 b=itaula[i].size(); // perfil inicial
      	faux = faux + (log((double)a)/log((double)2));
      	#ifdef DEBUG_COST
      	printf("\n argument %d",i);
 		printf("\n tamany  const%d, este %d",b,a);
 		#endif
	//      faux1 = faux1 + b*(log(ttaula[i].cant)/log(2))+ (log(b)/log(2)) ;	
		//    faux1 = faux1 + b*(a)+ b ;
		faux1 = faux1 + a*(b)+ a ;
	 }
	 else if  (dt.KindOf(i)==NUMERIC_KIND)
	   {
	      faux=faux+COST_REAL;
	      }
    }
      // perfil_taula[j]=b;

      cost_ejem = faux*nej;
      //    if (b==a)faux = faux + b*(perfil[j])+ b ;
      //  else faux = faux + a + b;
      #ifdef DEBUG_COST
      printf("\n ejemplos= %d",nej);
      printf("\n coste_ejemplos=%f",cost_ejem);
      printf("\n coste taula = %f", faux1);
		printf("\n coste total = %f", faux1+cost_ejem+nej);
		#endif
      return faux1+cost_ejem+nej;
}



double calcula_partv(const vector<bool>  &OV)
{
  unsigned int nvar=0,i;
  double res=1;

  for (i=0;i<OV.size();i++)
    if (OV[i]) nvar++;
  res= log((double)10)/log((double)2) + log((double)nvar+1)/log((double)2);
  //  printf(" coste_particion=%f\n",res);
  return res;
}
