/***************************************************************************
                          estructures.h  -  description
                             -------------------

    functionality        : some basic definitions about types
    relevant classes     : argument, variable, discrete, numeric, ...
    relevant functions   :

    begin                : Thu Dec 6 2001
    copyright            : (C) 2001 by Cesar Ferri, Jose Hernandez
    email                : {cferri,jorallo}@dsic.upv.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ESTRUCTURES_H
#define ESTRUCTURES_H


#include <vector>
#include <string>

using namespace std;  // This is needed for some compilers

// Define this variable when output is interactive. Disable if output is to a file.
// #define VERBOSE

typedef unsigned char byte;
typedef unsigned short int word;
typedef unsigned long word4;

typedef float numeric;     // used for numerical attributes
typedef byte discrete;     // used for nominal attributes
typedef int variable;      // used for variables
// typedef struct { float f, bool b } numeric_with_unknown;  // used for numerical attributes with missing values
typedef word4 indext;      // used for indexes in datasets

typedef enum { EMPTY, CONST_EQ, CONST_NEQ, VAR_EQ, VAR_NEQ, NUM_LT, NUM_GE, NUM_LT_WU, NUM_GE_WU, NUM_MISSING } cond_op;

typedef enum { IGNORE_KIND=-2, NUMERIC_WITH_UNKNOWN_KIND= -1, NUMERIC_KIND, DISCRETE_KIND, VARIABLE_KIND } kind;

const float MISSING_NUMERIC= -0.10101010101010101010;

/* taula de arguments*/
typedef vector <string> argtable;
typedef vector<argtable> exetablet;

typedef byte indargtable;
//typedef byte *example;

/* exemples*/
typedef word argoffsetv;
typedef argoffsetv argoffsett;
typedef word sizeexamplet;
typedef vector<indext> vdistt; // distribuci de clases

/* tipus*/
typedef vector<kind> typest;


class argument {
public:
  union { numeric Value_n; discrete Value_d; variable Value_v; };

  argument () {
    Value_n = 0;
  }

  argument (numeric n) {
    Value_n = n;
  } 
  argument (discrete d) {
    Value_d = d;
  }
  argument (variable v) {
    Value_v = v;
  } // */   // No fa falta perque v i n son del mateix tipus
};

#define SBYTE sizeof(byte)
#define SWORD sizeof(word)
#define SNUMERIC sizeof(numeric)
#define SIGNORE 0

/*
long num_exemples;
int num_arguments; //
sizeexamplet size_example;//
vector<example> traindataset;//
argoffsett *argoffset;//
exetablet exetable;//
typest types;//
*/

#endif
