/***************************************************************************
                          roc.cpp  -  description
                             -------------------

    functionality        : ROC facilities
    relevant classes     :
    relevant functions   : compute_ROC_points, compute_ROC_AREA, genera_ps

    begin                : 10 Dec 2001
    copyright            : (C) 2001 by Cesar Ferri, Jose Hernandez
    email                : {cferri,jorallo}@dsic.upv.es
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include <iostream>
#include <cmath>
#include <cstdlib>
#include <time.h>
#include <vector>
#include <cstdio>
// #include <io>   // this was required for some compilers. The error was that the function "open" is not recognised. Now fopen is used instead
#include <fstream>
#include "trees.h"
#include <algorithm>
#include <cmath>

#include "estructures.h"

//#define MDEBUG       //depuracio
//#define JOSE         // calcul dels punts ROC segons l'ordre de Jose, veure paper Rocking...
#define HAND           // If active computes AUC by Hand's way
#define VAL_MAX 100.0

//int classes;
//int nodes;

//int confm [nodes][classes];

void obtain_node_distribution_2class(const vector<and_tree *> &solucio, int Roc_With, int Roc_Smooth, const options &Options,
                               vector<vector<double> > & solucioROC, int ca,int cb, int classes, int &nodes);
//=
//{{1,1,1}};
/*
{{1,3,5},
  {7,11,13},
 {17,23,67},
{75,2,37},
 {123,45,78},
 {31,29,37},
 {56,76,34},
 {34,55,23},
 {43,47,53},
{41,4,5},
{43,10,2},
};

int confm [nodes][classes]=
{{12,3,35,7},
  {67,1,13,9},
{3,4,11,23}};*/

/*void randomgenerator()
    {
      srand(static_cast<int>(time(0)));
      int j,i;

      for(i=0;i<nodes;i++)
	{   fulla f;
	for (j=0;j<classes;j++)
	  {f.push_back(1+(int) (VAL_MAX*rand()/(RAND_MAX+1.0)));}
	confm.push_back(f);
	}
      	
    }
*/

// A partir de una solucio (vecotor de nodes), y un vector amb l'assignaci de classes
// calcula una matriu de confusi

void gen_mat(int vectori[],int cmat[],const vector<vector<double> > &solucio,int classes,int nodes  )
{
int i=0,j;
for(i=0;i<nodes;i++)
  for (j=0;j<classes;j++)
    cmat[vectori[i] * classes+j] += static_cast<int>(solucio[i][j]);  // AC ES FA UNA CONVERSI DE DOUBLE A INT. EN REALITAT CMAT HAURIA DE SER DE int !!!!
#ifdef MDEBUG
  cout<<"matriu resultat"<<endl;
  for(i=0;i<nodes;i++)
   { for (j=0;j<classes;j++)
      { cout<<cmat[i*classes+j]<<" ";}
  cout<<endl;}
      cout<<endl;
#endif
}

// De una matriu de confusi el vector de distribuci, calcula la matriu normalitzada

void ompli_matriu(int *costm,double  *matriu,double *vectori, int classes )
{
  int i=0,j;

  for (i=0;i<classes;i++)
    for (j=0;j<classes;j++)
      matriu[i*classes+j]=((double)costm[i*classes+j])/vectori[j];

#ifdef MDEBUG
  cout<<"matriu normalitzada"<<endl;
  for(i=0;i<classes;i++)
  {  for (j=0;j<classes;j++)
      { cout<<matriu[i*classes+j]<<" ";}
  cout<<endl;}
  cout<<endl;
#endif
}

/*genera els punts per cada soluci en el espai ROC*/
void calcula_punt(double * matriu,vector<double>  &point)
{

#ifndef JOSE
   point.push_back(matriu[1]);
    point.push_back(matriu[0]);
#else
int i=0,j;
  for (i=0;i<classes;i++)
    for (j=0;j<classes;j++)
      if (i!=j) point.push_back(matriu[i*classes+j]);
      //cout<<endl;
#endif
}


inline double compute_ratio (double a, double b) {
  double num, den;
  num= a;
  den= a + b;
  if (den)
    return num / den;
  else
    return 0.5;
}

inline bool compara_ratio ( vector<double> c1, vector<double> c2) {
  double f1,f2;
  f1= compute_ratio(c1[0], c1[1]);

  f2= compute_ratio(c2[0], c2[1]);

	return (f1>f2);
}


inline bool compara_ratio2 ( vector<double> c1, vector<double> c2) {
  double f1,f2;
  f1= compute_ratio(c1[2], c1[3]);

  f2= compute_ratio(c2[2], c2[3]);

	return (f1>f2);
}


void obtain_node_distribution(const vector<and_tree *> &solucio, int Roc_With, int Roc_Smooth, const options &Options,
                               vector<vector<double> > & solucioROC, double *vectori,int ca, int cb, int classes, int &nodes) {

  int i;
  for (i=0;i<nodes;i++) {
//    for (int j=0;j<classes;j++) { Ara sols treballem en 2 classes aci
      double Valuea,Valueb;
      if (Roc_With == ROC_WITH_TRAIN) {  //  || (Roc_With == ROC_WITH_TRAIN_ORDER_TEST_FILL)) {
        double pEj,pEi;
        and_tree *AT= solucio[i];
        indext Card= AT->Cardinality;
        if (Card == 0) {
          pEj= 0;
          pEi= 0;
        }
        else {
          if (Roc_Smooth == ROC_WITH_TRAIN_NO_SMOOTH) {
					  pEi= AT->ClassDistribution[ca];
						pEj= AT->ClassDistribution[cb];
          }
          else if (Roc_Smooth == ROC_WITH_TRAIN_PLUS1_SMOOTH) {
					  pEi= AT->ClassDistribution[ca]+1;
						pEj= AT->ClassDistribution[cb]+1;
          }
          else if (Roc_Smooth == ROC_WITH_TRAIN_LAPLACE_SMOOTH) {
					  pEi= Card * ((AT->ClassDistribution[ca]+1) / double(Card + classes));
						pEj= Card * ((AT->ClassDistribution[cb]+1) / double(Card + classes));
          }
          else { // ROC_WITH_TRAIN_SMOOTH_AS_ENABLED_FOR_FREQUENCY
            if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_SMOOTHING) {
							pEi= AT->SmoothDistribution[ca] * (double)Card;
							pEj= AT->SmoothDistribution[cb] * (double)Card;
						}
            else if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_NO_SMOOTHING)	{
							pEi= AT->ClassDistribution[ca];
							pEj= AT->ClassDistribution[cb];
						}
          }
        }
        Valuea= pEi;
				Valueb= pEj;
      }
      else {
        if (solucio[i]->TestDistribution.size() == 0)
          {
					Valuea= 0;
					Valueb= 0;     // Nodes with no test examples under them are NOT INITIALISED
					}
        else
					{
          Valuea= solucio[i]->TestDistribution[ca];
					Valueb= solucio[i]->TestDistribution[cb];					
					}
      }
      vectori[0]+= Valuea;    // S'HAURIA DE CONVERTIR vectori de vector<int> a vector<double>
      vectori[1]+= Valueb;

  }
                //} del for de classes
/*
  cout << "Vector of classes: " << endl;
  cout << "  Class 0: " << vectori[0] << endl;
  cout << "  Class 1: " << vectori[1] << endl;
*/
   /* copiem la solucio en un vector ja que ho tenim que ordenar i millor no marejar la perdiu..*/
	int eliminats=0;
	for(i=0;i<nodes;i++) {
      if (Roc_With == ROC_WITH_TRAIN) {  // || (Roc_With == ROC_WITH_TRAIN_ORDER_TEST_FILL)) {
        vector<double> Pair;
        and_tree *AT= solucio[i];
        indext Card= AT->Cardinality;
        if (Card == 0) {
          Pair.push_back(0);
          Pair.push_back(0);
        }
        else {
          if (Roc_Smooth == ROC_WITH_TRAIN_NO_SMOOTH) {
						Pair.push_back(AT->ClassDistribution[ca]);
						Pair.push_back(AT->ClassDistribution[cb]);
          }
          else if (Roc_Smooth == ROC_WITH_TRAIN_PLUS1_SMOOTH) {
					  Pair.push_back(AT->ClassDistribution[ca]+1);
						Pair.push_back(AT->ClassDistribution[cb]+1);
          }
          else if (Roc_Smooth == ROC_WITH_TRAIN_LAPLACE_SMOOTH) {
					  Pair.push_back(Card * ((AT->ClassDistribution[ca]+1) / double(Card + classes)));
						Pair.push_back(Card * ((AT->ClassDistribution[cb]+1) / double(Card + classes)));
          }
          else { // ROC_WITH_TRAIN_SMOOTH_AS_ENABLED_FOR_FREQUENCY
            if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_SMOOTHING) {
              Pair.push_back(AT->SmoothDistribution[ca] * (double)AT->Cardinality);
              Pair.push_back(AT->SmoothDistribution[cb] * (double)AT->Cardinality);
            }
            else if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_NO_SMOOTHING) {
              Pair.push_back(AT->ClassDistribution[ca]);
              Pair.push_back(AT->ClassDistribution[cb]);
            }
          }
        }

   	 		if ((Pair[ca]+Pair[cb])>0)
	 			 	solucioROC.push_back(Pair);
	   		else {
	   		  solucioROC.push_back(Pair);  // ARA JA ES POT FER A PERQU COMPARA_RATIO VA B
	   		  // eliminats++;   //hem de tindre atenci als nodes amb 0,0 , no els copiem
	   		}
      }
      else {
        if ((solucio[i]->TestDistribution.size() != 0)  // Nodes with no test examples under them are NOT INITIALISED
             && ((solucio[i]->TestDistribution[ca]+solucio[i]->TestDistribution[cb])>0))
	 			 {
					vector<double> Pair1;
          Pair1.push_back(solucio[i]->TestDistribution[ca]);
          Pair1.push_back(solucio[i]->TestDistribution[cb]);
					solucioROC.push_back(Pair1);
					}
	   	  else {
	   	    vector<double> Pair;
          Pair.push_back(0);
          Pair.push_back(0);	
      	  solucioROC.push_back(Pair);  // ARA JA ES POT FER A PERQU COMPARA_RATIO VA B     	
	   		  // eliminats++;   //hem de tindre atenci als nodes amb 0,0 , no els copiem
	   		}
      }
  }

//  cout << "Nodes with 0 examples eliminated: " << eliminats << endl;
  nodes=nodes-eliminats;// hem eliminat nodes


}



// computa els punts en el espai ROC de una soluci concreta
// el retorna en un vector<and_tree *> &solucio
void compute_ROC_points(const vector<and_tree *> &solucio,vector<vector<double> > &points, int Roc_With, const options & Options,int ci, int cj)
{
//  classes=solucio[0]->ClassDistribution.size();// number of classes
 /* if (classes != 2)
    cout << "iep" ;
  */
int  nodes,classes=2; //Aci no te sentit treballar amb mes classes
  nodes=solucio.size();// number of nodes
/*	
  int dim;
  dim= classes*(classes-1);
*/  double *matriu;
  int i;
  // static int vass[nodes];
  int *vass, *cmat;
/*solucio[0]->ClassDistribution[0]=5;
solucio[0]->ClassDistribution[1]=1;
solucio[2]->ClassDistribution[0]=4;
solucio[2]->ClassDistribution[1]=2;
solucio[1]->ClassDistribution[0]=3;
solucio[1]->ClassDistribution[1]=5;
nodes=3;*/
 double *vectori =(double*) calloc(classes,sizeof(double));
 vector<vector<double> > solucioROC;
//   obtain_node_distribution(solucio, Roc_With, Options, solucioROC, vectori);
  obtain_node_distribution(solucio, Roc_With, ROC_WITH_TRAIN_LAPLACE_SMOOTH, Options, solucioROC, vectori,ci,cj,classes,nodes );


  if (classes==2) {
    if (Roc_With == ROC_WITH_TRAIN_ORDER_TEST_FILL) {
 	      vector<vector<double> > solucioROCOrderTrain;
 	
        obtain_node_distribution_2class(solucio, ROC_WITH_TRAIN, ROC_WITH_TRAIN_LAPLACE_SMOOTH, Options, solucioROCOrderTrain,ci,cj, classes,nodes);
   			
   			// sort(solucioROC.begin(), solucioROC.end(), compara_ratio);
   			
//   		  cout << "Tenim la size de solucioROC: " << solucioROC.size() << endl;
//   		  cout << "Tenim la size de solucioROCOrderTrain: " << solucioROCOrderTrain.size() << endl;
   		     		
   		  // This adds to coordinates [2] and [3] the values from solucioROCOrderTrain [0] and [1]
   		  // Now we have 4 dimensions and we use the first two for usual things and the other two for ordering
   		  for (int j=0; j < nodes; j++) {
   		    solucioROC[j].push_back(solucioROCOrderTrain[j][0]);
      		solucioROC[j].push_back(solucioROCOrderTrain[j][1]);		
   		  }
    }
  }




  matriu =(double*) calloc(classes*classes,sizeof(double));
  vass =(int*) calloc(nodes,sizeof(int));

  cmat =(int*) calloc(classes*classes,sizeof(int));
  //confm= (int*) calloc(classes*nodes,sizeof(int));
  /* imprimim dimensions*/
  //cout<<dim<<endl;
  //cout<<pow(classes,nodes)+dim+1<<endl;
  /* imprimim punts oritge*/
/*  for (i=0;i<dim;i++)
    cout<<"1 ";
  cout<<endl;
  for(j=0;j<dim;j++)
    {
      for (i=0;i<dim;i++)
	{
	  if (i==j) cout<<"1 ";
	  else cout<<"0 ";
	}
      cout<<endl;
    }


  randomgenerator();*/

#ifdef MDEBUG
  cout<<"matriu"<<endl;
    for(i=0;i<nodes;i++)
    {
      for (int j=0;j<classes;j++)
	{ cout<<solucioROC[i][j]<<" ";}
      cout<<endl;
    }
    cout<<endl;
#endif


#ifdef MDEBUG
  cout<<"vector"<<endl;
  for(i=0;i<classes;i++)
    cout<<vectori[i]<<" ";
  cout<<endl;
#endif



//for (unsigned int k=0;k< solucioROC.size();k++)
// {
//		cout<<k<<":"<<solucioROC[k][0]<<","<<solucioROC[k][1]<<","<<solucioROC[k][2]<<","<<solucioROC[k][3]<<","<<endl;
//}

for(i=0;i<nodes;i++)
 vass[i]=1;

if (classes==2)
   {


      if (Roc_With != ROC_WITH_TRAIN_ORDER_TEST_FILL) {
   			sort(solucioROC.begin(), solucioROC.end(),compara_ratio);
   		}
   		else {
   		  // ordena amb el training set ara que estan omplits amb el test" << endl;
   			sort(solucioROC.begin(), solucioROC.end(),compara_ratio2);
   			
   			// random_shuffle(solucioROC.begin(), solucioROC.end());  // a ho desordenaria. Tendix a donar 0.5
   			
        // compara_ratio2 accedix a [2] i [3] per a ordenar..     		
   		}


			
			
			
			#ifdef MDEBUG
		  cout<<"matriu ordenada"<<endl;
    		for(i=0;i<nodes;i++)
   				 {
			      for (int j=0;j<classes;j++)
					{ cout<<solucioROC[i][j]<<" ";}
			      cout<<endl;
    			}
				    cout<<endl;
			#endif
			 int cont=0;


	  for (cont=0;cont<nodes+1;cont++)	
    {

      int i1,j1;
			#ifdef MDEBUG
      		cout<<"assignacio"<<endl;
      		for(i1=0;i1<nodes;i1++)
						cout<<vass[i1]<<" ";
			      cout<<endl;
			#endif



     for (i1=0;i1<classes;i1++)
			for (j1=0;j1<classes;j1++)
	 			 cmat[i1*classes+j1]=0;
	 			
      gen_mat(vass,(int*)cmat,solucioROC,classes,nodes);
      ompli_matriu((int*)cmat,(double*)matriu,vectori,classes);
      vector<double>  point;
      calcula_punt((double*)matriu,point);
      points.push_back(point);
       //calcula segent assignaci
      if (cont<nodes) vass[cont]--;

    }
   }	

else //hi han mes de 2 classes ara per ara no te massa sentit
{       cout<<"ERROR ACI no es deuria de entrar, estic calculant punts ROC per a mes de 2 classes"<<endl;
/*  do	
    {
      int i1,j1;

#ifdef MDEBUG
      cout<<"assignacio"<<endl;
      for(i1=0;i1<nodes;i1++)
	cout<<vass[i1]<<" ";
      cout<<endl;
#endif

     for (i1=0;i1<classes;i1++)
			for (j1=0;j1<classes;j1++)
	 			 cmat[i1*classes+j1]=0;
	 			
      gen_mat(vass,(int*)cmat,solucioROC);
      ompli_matriu((int*)cmat,(double*)matriu,vectori);
      vector<double>  point;
      calcula_punt((double*)matriu,point);
      points.push_back(point);
      i1=0;
      //calcula segent assignaci
      while(vass[i1]==classes-1)
      	i1++;
      if (i1==nodes) break;
      else for(j1=0;j1<i1;j1++)
	vass[j1]=0;
      vass[i1]++;
    }
  while(1);
    */

  }//del else
  //  free(confm);


  free(cmat);  // dna problemes si es borra (prova monks2 amb ROC split i k-fold)

  free(vass);
  free(vectori);
  free(matriu);
 
}



void compute_ROC_AREA(const vector<vector<double> > &points, double & Area) {
  Area= 0;
  unsigned long Intervals= points.size()-1;
  for (unsigned long i=0; i < Intervals; i++) {
    double x0= points[i][0];
    double y0= points[i][1];
    double x1= points[i+1][0];
    double y1= points[i+1][1];

    double DiffX= x1-x0;
    double MeanY= (y1+y0)/2.0;
    Area+= DiffX * MeanY;
  }
}

void genera_ps(const vector<vector<double> > &points, const char *filed) {
  FILE *fd2;
  char buff[180];

  fd2 = fopen(filed, "w");

  strcpy(buff,"%!\n");

  // write(fd2,buff,strlen(buff));	
  fwrite(buff, 1, strlen(buff), fd2);	
  //strcpy(buff,"1.4151 1  scale\n");
  //write(fd2,buff,strlen(buff));	
  strcpy(buff,"1.031 1  scale\n");
  fwrite(buff, 1, strlen(buff), fd2);	
  strcpy(buff,"newpath\n");
  fwrite(buff, 1, strlen(buff), fd2);	
  strcpy(buff,"100 100 moveto\n");	
  fwrite(buff, 1, strlen(buff), fd2);	
  strcpy(buff,"100 400 lineto\n");	
  fwrite(buff, 1, strlen(buff), fd2);	
  strcpy(buff,"100 100 moveto\n");	
  fwrite(buff, 1, strlen(buff), fd2);	
  strcpy(buff,"400 100 lineto\n");	
  fwrite(buff, 1, strlen(buff), fd2);	
  strcpy(buff,"4 setlinewidth\n");	
  fwrite(buff, 1, strlen(buff), fd2);	
  strcpy(buff,"stroke\n");		
  fwrite(buff, 1, strlen(buff), fd2);	
  #ifndef JOSE
    strcpy(buff,"100 100 moveto\n");	
    fwrite(buff, 1, strlen(buff), fd2);	
  #else
  strcpy(buff,"100 400 moveto\n");	
  fwrite(buff, 1, strlen(buff), fd2);	
  #endif

  unsigned int i,x,y;
  for (i=0;i<points.size();i++) {
    x=(int)(points[i][0]*300+100);
    y=(int)(points[i][1]*300+100);
    sprintf(buff,"%d %d lineto\n",x,y);
    fwrite(buff, 1, strlen(buff), fd2);	
    sprintf(buff,"%d %d moveto\n",x,y);
    fwrite(buff, 1, strlen(buff), fd2);	
  }
  strcpy(buff,"0.8 setlinewidth\n");	
  fwrite(buff, 1, strlen(buff), fd2);	
  strcpy(buff,"stroke\n");		
  fwrite(buff, 1, strlen(buff), fd2);	
  strcpy(buff,"showpage\n");
  fwrite(buff, 1, strlen(buff), fd2);	

  fclose(fd2);
}




float compute_MSE(const vector<and_tree *> &solucio, const options & Options, int With) {

  int NClasses =solucio[0]->ClassDistribution.size();// number of classes
  long NNodes= solucio.size();
  double MSE= 0;
  double TotalTestValue= 0;

  for(long i=0; i<NNodes; i++) {
    if (With == MSE_WITH_TEST) {
      if (solucio[i]->TestDistribution.size() == 0) {
        // Nodes with no test examples under them are NOT INITIALISED
        // in any case, they don't increase MSE.
        continue;
      }
    }

    long Card= solucio[i]->Cardinality;
    double MSE0= 0;
    for(int j=0; j<NClasses; j++) {
      long TestValue;
      if (With == MSE_WITH_TEST) {
        TestValue= solucio[i]->TestDistribution[j];
      }
      else {
        TestValue= solucio[i]->ClassDistribution[j];
      }

/*    if (With != MSE_WITH_TEST) {
         TestValue++; // DOUBLE SMOOTHING!!
      }
*/

      for(int k=0; k<NClasses; k++) {

        double ProbTrain;
        if (Card == 0) {  // We assume equal probability for all the classes
          ProbTrain = 1 / double(NClasses);
        }
        else {
          double TrainValue;
          if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_SMOOTHING)
            TrainValue= solucio[i]->SmoothDistribution[k] * (double)Card;    // THIS WAS TRUNCATED TO A LONG + 0.5 BEFORE.
          else if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_NO_SMOOTHING)
            TrainValue= solucio[i]->ClassDistribution[k];
          ProbTrain= TrainValue / double(Card);
        }

//        const double Pot=2;
        if (j!=k) {
          MSE0+= TestValue * Sqr(0-ProbTrain);
          // MSE0+= TestValue * fabs(pow(0-ProbTrain, Pot));
        }
        else {
          MSE0+= TestValue * Sqr(1-ProbTrain);
          // MSE0+= TestValue * fabs(pow(1-ProbTrain, Pot));
          // MSE0+= TestValue * fabs(1-ProbTrain);

          // MSE0+= sqrt(TestValue * Sqr(1-ProbTrain));

        }
      }



      TotalTestValue+= TestValue;
    }
    MSE+= MSE0;
  }

  MSE= MSE / TotalTestValue;

  return MSE;
}






float compute_LogLoss(const vector<and_tree *> &solucio, const options & Options, int With) {

  int NClasses =solucio[0]->ClassDistribution.size();// number of classes
  long NNodes= solucio.size();
  double MSE= 0;
  double TotalTestValue= 0;

  for(long i=0; i<NNodes; i++) {
    if (With == MSE_WITH_TEST) {
      if (solucio[i]->TestDistribution.size() == 0) {
        // Nodes with no test examples under them are NOT INITIALISED
        // in any case, they don't increase MSE.
        continue;
      }
    }

    long Card= solucio[i]->Cardinality;
    double MSE0= 0;
    for(int j=0; j<NClasses; j++) {
      long TestValue;
      if (With == MSE_WITH_TEST) {
        TestValue= solucio[i]->TestDistribution[j];
      }
      else {
        TestValue= solucio[i]->ClassDistribution[j];
      }

   //   if (With != MSE_WITH_TEST) {
   //      TestValue++; // DOUBLE SMOOTHING!!
   //   }

      double ProbTrain;
      double TrainValue;
      if (Card == 0) {  // We assume equal probability for all the classes
        ProbTrain = 1 / double(NClasses);
      }
      else {
        if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_SMOOTHING)
          TrainValue= solucio[i]->SmoothDistribution[j] * (double)Card;
        else if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_NO_SMOOTHING)
          TrainValue= solucio[i]->ClassDistribution[j];
        ProbTrain= TrainValue / double(Card);
      }


      double Val;
      const double Lim= 1000000;
      if (ProbTrain == 0) {
        // Val = Lim;
        ProbTrain = (TrainValue +1) / double(Card); // Forced smoothing to avoid -infinite
      }

      {
        Val = -log2(ProbTrain);
        // Val= -log(ProbTrain); // neperian
        if (Val > Lim) {
          Val= Lim;
        }
      }


      // TestValue++; // DOUBLE SMOOTHING!!!

      if ((Val == Lim) && (TestValue != 0)) {
        cout << "iep";
      }

      MSE0+= TestValue * Val;


      TotalTestValue+= TestValue;
    }
    MSE+= MSE0;
  }

  MSE= MSE / TotalTestValue;

  return MSE;
}



/* bolca les distribucions de dos classes donades de una solucio a un vector*/
void obtain_node_distribution_2class(const vector<and_tree *> &solucio, int Roc_With, int Roc_Smooth, const options &Options,
                               vector<vector<double> > & solucioROC, int ca,int cb, int classes, int &nodes)
 {



/*
  cout << "Vector of classes: " << endl;
  cout << "  Class 0: " << vectori[0] << endl;
  cout << "  Class 1: " << vectori[1] << endl;
*/
   /* copiem la solucio en un vector ja que ho tenim que ordenar i millor no marejar la perdiu..*/
	int eliminats=0;
	for(int i=0;i<nodes;i++) {
      if (Roc_With == ROC_WITH_TRAIN) {  // || (Roc_With == ROC_WITH_TRAIN_ORDER_TEST_FILL)) {
        vector<double> Pair;
        and_tree *AT= solucio[i];
        indext Card= AT->Cardinality;
        if (Card == 0) {
          Pair.push_back(0);
          Pair.push_back(0);
        }
        else {
          if (Roc_Smooth == ROC_WITH_TRAIN_NO_SMOOTH) {
						Pair.push_back(AT->ClassDistribution[ca]);
						Pair.push_back(AT->ClassDistribution[cb]);
          }
          else if (Roc_Smooth == ROC_WITH_TRAIN_PLUS1_SMOOTH) {
					  Pair.push_back(AT->ClassDistribution[ca]+1);
						Pair.push_back(AT->ClassDistribution[cb]+1);
          }
          else if (Roc_Smooth == ROC_WITH_TRAIN_LAPLACE_SMOOTH) {
						Pair.push_back(Card * ((AT->ClassDistribution[ca]+1) / double(Card + classes)));
						Pair.push_back(Card * ((AT->ClassDistribution[cb]+1) / double(Card + classes)));
          }
          else if (Roc_Smooth == ROC_WITH_TRAIN_M_SMOOTH) {
            double MM= Options.SmoothingInAUCH_MValue;
            // UNIFORM

            // WRT. TRAINING SET

						Pair.push_back(Card * ((AT->ClassDistribution[ca]+MM * (1 / double(classes))) / double(Card + MM)));
						Pair.push_back(Card * ((AT->ClassDistribution[cb]+MM * (1 / double(classes))) / double(Card + MM)));
          }
          else if (Roc_Smooth == ROC_WITH_TRAIN_MBRANCH_SMOOTH) {
            double MM= Options.SmoothingInAUCH_MValue;

			
				//		double m = classes;  // Provat i va b amb la nova cosa.
				double m= 3; // amb tres va lleugerament millor.
				//    double m= 3.5; // NOU.
				//		double m = 4; // Un poquet pitjor que 3
				//		double m = 2;
				
          //				    double m= log2(Root->Cardinality / double(AT->Cardinality));
				//    double m= logbase(10, Root->Cardinality / double(AT->Cardinality));
				
				
								
				
				   // FOR CALCULATING THE ROOT DISTRIBUTION AND PARTIAL DISTRIBUTION IN THE BRANCH TO THE LEAF
				    and_tree *Root= solucio[i];
            and_tree *FirstParent= NULL;
            bool Mean= true;
            long Depth= 0;
            double ma= -1.0, mb= -1.0;
            list<double> Va, Vb;
            list<double> VCard;

            do {
              or_tree *Parent= (or_tree *)(Root->Parent);
              if (Parent) {
                and_tree *GrandPa= (and_tree *)(Parent->Parent);
                if (GrandPa) {
                  Root= GrandPa;
                  double ka, kb;
                  ka= Root->ClassDistribution[ca];
                  kb= Root->ClassDistribution[cb];
                  double RCard= double(Root->Cardinality);

                  ka= ka / RCard;
						      kb= kb / RCard;

                  Va.push_front(ka);
                  Vb.push_front(kb);
                  VCard.push_front(RCard);

                  if (!FirstParent) {
                    FirstParent= Root;
                  }
                  else {
                    if (Mean) {
                      ma= ka;
                      mb= kb;
                      Mean= false;
                      Depth= 1;
                    }
                    else {
                     // ma= (ma + ka) / 2.0; // the higher (closer to the root) the more important
                     // mb= (mb + kb) / 2.0;
                     // Depth= 1

  ma+= ka;  // ALL EQUALLY IMPORTANT   // A S LO QUE VA B
  mb+= kb;
  Depth++;

                     /*
                       ma= (4.0/5.0)*ma + (1.0/5.0)*ka;  // the lower the more IMPORTANT
                       mb= (4.0/5.0)*mb + (1.0/5.0)*kb;
                       Depth=1;
                     */

                    }
                  }
                }
                else
                  break;
              }
              else
                break;
            }
            while(true);


            Va.push_front(1/double(classes));
            Vb.push_front(1/double(classes));
            VCard.push_front(-1.0);  // infinity, in reality. Don't care, this value shouldn't be used.


            if (Mean) {
              ma= 1.0 / double(classes);
              mb= 1.0 / double(classes);
            }
            else {
              ma/= Depth;
              mb/= Depth;
            }



            double ra, rb;
						double fa, fb;
						double CardParent= Card;  // NO S, PER FICAR ALGO PER A QUE NO PUGA SER ZERO
						
            // PARENT DISTRIBUTION
            if (FirstParent) {
              ra= FirstParent->ClassDistribution[ca];
              rb= FirstParent->ClassDistribution[cb];

              CardParent= double(FirstParent->Cardinality);
              fa= ra / CardParent;
						  fb= rb / CardParent;
            }
            else {
              fa= 1.0 / double(classes);
              fb= 1.0 / double(classes);
            }
										
						
						
						// fa= fb= 0.5;
						
						double pa, pb;
						// UNIFORME
//						pa= 1.0 / double(classes);  // A VA B.
//						pb= 1.0 / double(classes);

/*
						// GLOBAL DISTRIBUTION = TRAIN DISTRIBUTION
            if (Root) {
              pa= Root->ClassDistribution[ca];
              pb= Root->ClassDistribution[cb];
              pa /= double(Root->Cardinality);
						  pb /= double(Root->Cardinality);
            }
            else {
   						pa= 1.0 / double(classes);
		  				pb= 1.0 / double(classes);
            }
*/						
												
						// BRANCH DISTRIBUTION
						pa= ma;
						pb= mb;
						
						// ESTA ES LA BONA
						fa= (fa + pa) / 2.0;  // suavitzem  // A VA B amb m= classes, fa=parent, pa=uniforme!!!
						fb= (fb + pb) / 2.0;  // suavitzem

						// fa= (fa*CardParent + m*pa) / double(CardParent + m);
						// fb= (fb*CardParent + m*pb) / double(CardParent + m);

						
						// NOVA COSA
						
						double na, nb, Cardi;
						
						na= Va.front(); Va.pop_front();
						nb= Vb.front(); Vb.pop_front();
						Cardi= VCard.front(); VCard.pop_front();

            int co= 0;
/*
            // A NOMS PER A LA MITJA
						co= 1;			
						if (Va.size() > 1) {  // si hi ha almenys un pare no tindre-ho en compte
						  co= 0;
						  na= nb= 0;
						}

						while (Va.size() > 1) {				
*/
            double Height= Va.size();
            double MaxHeight = Height;

						while (Va.size() > 0) {
  						double ma, mb, Cardj;										 						
 							ma= Va.front(); Va.pop_front();
	  					mb= Vb.front(); Vb.pop_front();
		  				Cardj= VCard.front(); VCard.pop_front();
		  			
		  			  double mm= 80; // m;  // AMB 80 va molt b
		  		//	  double mm= 100;
//		  			  double mm= max(3.0, sqrt(Cardj)); // m;
//	   			    double mm= 3.0 + sqrt(Cardj); // m;
		  			
//              mm= pow(4, Height + 2);
           //   mm= 4 * pow(2, Height);
           //     mm= 4 * (3*Height + 1); // va b ms o menys.
            //      mm= 4 * (12*sqrt(Height) + 1); // VA QUASI TAN B COM LO DE 80
            //      mm= 3 * (sqrt(double(Root->Cardinality)) *log(Height + 1) + 1); // VA MOLT B, QUASI QUASI IGUAL QUE EL DE 80
            //    mm= 4 * (sqrt(double(Root->Cardinality)) *log(Height + 1) + 1); // VA MOLT B, QUASI QUASI IGUAL QUE EL DE 80
            //    mm= 3 * ((log2(double(Root->Cardinality)) * Height + 1) + 1); // VA UN POQUET PITJOR
            //    mm= 3 * ((log2(double(Root->Cardinality)) * 2 * Height + 1) + 1); // pitjor
            //    mm= 3 * ((log(double(Root->Cardinality)) * 2 * Height + 1) + 1); // pitjor

             //    mm= 4 * ((sqrt(double(Root->Cardinality))));  //  LA MILLOR

             //    mm= 3 * ((sqrt(double(Root->Cardinality))));  // MOLT B TAMB

             //    mm= 5 * ((sqrt(double(Root->Cardinality))));  // MILLOR QUE LA MILLOR

                 double NormHeight= 1 - (1 / exp(Height));   // Height between 0 and 1
/*
                 mm= 3 * ( NormHeight * (2*sqrt(double(Root->Cardinality)))  + 1   );  // ESTE S QUE S EL MILLOR


                 // EL MILLOR DELS MILLORS
                 mm= 4 * ( NormHeight * (sqrt(double(Root->Cardinality)))  + 1   );
                 m= 4;

                 // QUE NO. ESTA MOLT MILLOR
                 mm= 5 * ( NormHeight * (sqrt(double(Root->Cardinality)))  + 1   );
                 m= 5;
*/

                 // ENCARA MILLOR
                 mm= MM * ( NormHeight * (sqrt(double(Root->Cardinality)))  + 1   );
                 m= MM;


                 // * (-1 + pow(2.0, Height / MaxHeight)) + 1)); //

                Height--;
		  				
		  				na= (ma*Cardj+mm*na) / double(Cardj + mm);
		  				nb= (mb*Cardj+mm*nb) / double(Cardj + mm);
						
/*
						  if (co == 0) {  // IGNORE THE 1/nclass superparent
						    na= ma;
						    nb= mb;
						  }
						  else {
//		  				  na= (na + ma) / 2.0;
//		  				  nb= (nb + mb) / 2.0;
		  				  na= (3.0/4.0)*na + (1.0/4.0)*ma;
		  				  nb= (3.0/4.0)*nb + (1.0/4.0)*mb;
		  				}
		  				co++;
*/
/*
		  				na+= ma;
		  				nb+= mb;
		  				co++;
*/						
						}

/*						
						na= na / co;
						nb= nb / co;
*/
/*						
						if (Va.size() > 0) {
							double ma, mb, Cardj;										 						
 						  ma= Va.front(); Va.pop_front();
  					  mb= Vb.front(); Vb.pop_front();
	  				  Cardj= VCard.front(); VCard.pop_front();

  	  				na= (na + ma) / 2.0;
	    				nb= (nb + mb) / 2.0;
	    			}
*/
	  										
						// NOVA PROVA. SI HO LLEVEM TENIM LO MILLOR FINS ARA
						fa= na;
						fb= nb;
						
												
					// ESTA ES LA BONA													
						Pair.push_back(Card * ((AT->ClassDistribution[ca]+m*(fa)) / double(Card + m)));
						Pair.push_back(Card * ((AT->ClassDistribution[cb]+m*(fb)) / double(Card + m)));
										

          // ESTA ES BONA	(amb m = classes)	
         //						Pair.push_back(Card * ((AT->ClassDistribution[ca]+ 1 + fa) / double(Card + m)));//
          //						Pair.push_back(Card * ((AT->ClassDistribution[cb]+ 1 + fb) / double(Card + m)));

         // simplement desambiguar		
          //						Pair.push_back(Card * ((AT->ClassDistribution[ca]+ fa/Card) / double(Card)));
          //						Pair.push_back(Card * ((AT->ClassDistribution[cb]+ fb/Card) / double(Card)));

          }
          else { // ROC_WITH_TRAIN_SMOOTH_AS_ENABLED_FOR_FREQUENCY
            if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_SMOOTHING) {
              Pair.push_back(AT->SmoothDistribution[ca] * (double)AT->Cardinality);
              Pair.push_back(AT->SmoothDistribution[cb] * (double)AT->Cardinality);
            }
            else if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_NO_SMOOTHING) {
              Pair.push_back(AT->ClassDistribution[ca]);
              Pair.push_back(AT->ClassDistribution[cb]);
            }
          }
        }

        /*
   	 		 if ((Pair[0]+Pair[1])>0)
	 			*/ 	solucioROC.push_back(Pair);
	   		/* else {
	   		  solucioROC.push_back(Pair);  // ARA JA ES POT FER A PERQU COMPARA_RATIO VA B
	   		  // eliminats++;   //hem de tindre atenci als nodes amb 0,0 , no els copiem
	   		}
	   		*/
      }
      else {
        if ((solucio[i]->TestDistribution.size() != 0)  // Nodes with no test examples under them are NOT INITIALISED
             && ((solucio[i]->TestDistribution[ca]+solucio[i]->TestDistribution[cb])>0))
	 			 	{
					vector<double> Pair;
          Pair.push_back(solucio[i]->TestDistribution[ca]);
          Pair.push_back(solucio[i]->TestDistribution[cb]);
					solucioROC.push_back(Pair);
					}
	   	  else {
	   	    vector<double> Pair;
          Pair.push_back(0);
          Pair.push_back(0);	
      	  solucioROC.push_back(Pair);  // ARA JA ES POT FER A PERQU COMPARA_RATIO VA B     	
	   		  // eliminats++;   //hem de tindre atenci als nodes amb 0,0 , no els copiem
	   		}
      }
  }

//  cout << "Nodes with 0 examples eliminated: " << eliminats << endl;
  nodes=nodes-eliminats;// hem eliminat nodes
}




/* bolca les distribucions de una classe en front a la resta donades de una solucio a un vector*/
void obtain_node_distribution_1vsAll(const vector<and_tree *> &solucio, int Roc_With, int Roc_Smooth, const options &Options,
                               vector<vector<double> > & solucioROC, int ca,int classes, int &nodes)
 {


/*
  cout << "Vector of classes: " << endl;
  cout << "  Class 0: " << vectori[0] << endl;
  cout << "  Class 1: " << vectori[1] << endl;
*/
   /* copiem la solucio en un vector ja que ho tenim que ordenar i millor no marejar la perdiu..*/
	int eliminats=0;
	for(int i=0;i<nodes;i++) {
      if (Roc_With == ROC_WITH_TRAIN) {  // || (Roc_With == ROC_WITH_TRAIN_ORDER_TEST_FILL)) {
        vector<double> Pair;
        and_tree *AT= solucio[i];
        indext Card= AT->Cardinality;

        if (Card == 0) {
          Pair.push_back(0);
          Pair.push_back(0);
        }
        else {
          if (Roc_Smooth == ROC_WITH_TRAIN_NO_SMOOTH) {
            Pair.push_back(AT->ClassDistribution[ca]);
            Pair.push_back(AT->Cardinality - AT->ClassDistribution[ca]);
          }
          else if (Roc_Smooth == ROC_WITH_TRAIN_PLUS1_SMOOTH) {
            Pair.push_back(AT->ClassDistribution[ca]+1);
            Pair.push_back(AT->Cardinality - AT->ClassDistribution[ca]+ classes - 1);
          }
          else if (Roc_Smooth == ROC_WITH_TRAIN_LAPLACE_SMOOTH) {
						Pair.push_back(Card * ((AT->ClassDistribution[ca]+1) / double(Card + classes)));
						Pair.push_back(Card * ((AT->Cardinality - AT->ClassDistribution[ca]+ classes - 1) / double(Card + classes)));
          }
          else { // ROC_WITH_TRAIN_SMOOTH_AS_ENABLED_FOR_FREQUENCY
            if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_SMOOTHING) {
              Pair.push_back(AT->SmoothDistribution[ca] * (double)AT->Cardinality);
              Pair.push_back((1-AT->SmoothDistribution[ca]) * (double)AT->Cardinality);
            }
            else if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_NO_SMOOTHING) {
              Pair.push_back(AT->ClassDistribution[ca]);
              Pair.push_back(AT->Cardinality - AT->ClassDistribution[ca]);
            }
          }
        }

        /*
   	 		if ((Pair[0]+Pair[1])>0)
	 			*/ 	solucioROC.push_back(Pair);
	   		/* else {
	   		  solucioROC.push_back(Pair);  // ARA JA ES POT FER A PERQU COMPARA_RATIO VA B
	   		  // eliminats++;   //hem de tindre atenci als nodes amb 0,0 , no els copiem
	   		}
	   		*/
	   		
      }
      else {
        unsigned long TestDistRest= 0;
        for(unsigned int j=0; j < solucio[i]->TestDistribution.size(); j++) {
          if ((unsigned int)ca != j)
            TestDistRest+= solucio[i]->TestDistribution[j];
        }

        if ((solucio[i]->TestDistribution.size() != 0)  // Nodes with no test examples under them are NOT INITIALISED
             && ((solucio[i]->TestDistribution[ca]+TestDistRest)>0)) {
					vector<double> Pair;
          Pair.push_back(solucio[i]->TestDistribution[ca]);
          Pair.push_back(TestDistRest);
					solucioROC.push_back(Pair);
					}
	   	  else {
	   	    vector<double> Pair;
          Pair.push_back(0);
          Pair.push_back(0);	
      	  solucioROC.push_back(Pair);  // ARA JA ES POT FER A PERQU COMPARA_RATIO VA B     	
	   		  // eliminats++;   //hem de tindre atenci als nodes amb 0,0 , no els copiem
	   		}
      }
  }

//  cout << "Nodes with 0 examples eliminated: " << eliminats << endl;
  nodes=nodes-eliminats;// hem eliminat nodes
}







/* bolca les distribucions d'un conjunt de classes en front a la resta donades de una solucio a un vector*/
void obtain_node_distribution_General(const vector<and_tree *> &solucio, int Roc_With, int Roc_Smooth, const options &Options,
                               vector<vector<double> > & solucioROC, const vector<int> &cav, const vector<int> &cbv, int classes, int &nodes)
 {

 // cav are the list of classes on the left
 // cbv are the list of classes on the right
 // A(cav, cbv)
 double Left=0;
 double Right=0;


/*
  cout << "Vector of classes: " << endl;
  cout << "  Class 0: " << vectori[0] << endl;
  cout << "  Class 1: " << vectori[1] << endl;
*/
   /* copiem la solucio en un vector ja que ho tenim que ordenar i millor no marejar la perdiu..*/
	int eliminats=0;
	for(int i=0;i<nodes;i++) {
      if (Roc_With == ROC_WITH_TRAIN) {  // || (Roc_With == ROC_WITH_TRAIN_ORDER_TEST_FILL)) {
        vector<double> Pair;
        and_tree *AT= solucio[i];
        indext Card= AT->Cardinality;

        if (Card == 0) {
          Pair.push_back(0);
          Pair.push_back(0);
        }
        else {
          unsigned int i;
          if (Roc_Smooth == ROC_WITH_TRAIN_NO_SMOOTH) {
            Left= 0;
            for(i=0; i < cav.size(); i++) {
              int c= cav[i];
              Left+= AT->ClassDistribution[c];
            }
            Right= 0;
            for(i=0; i < cbv.size(); i++) {
              int c= cbv[i];
              Right+= AT->ClassDistribution[c];
            }

            Pair.push_back(Left);
            Pair.push_back(Right);
          }
          else if (Roc_Smooth == ROC_WITH_TRAIN_PLUS1_SMOOTH) {
            Left= 0;
            for(i=0; i < cav.size(); i++) {
              int c= cav[i];
              Left+= AT->ClassDistribution[c] + 1;
            }
            Right= 0;
            for(i=0; i < cbv.size(); i++) {
              int c= cbv[i];
              Right+= AT->ClassDistribution[c] + 1;
            }

            Pair.push_back(Left);
            Pair.push_back(Right);
          }
          else if (Roc_Smooth == ROC_WITH_TRAIN_LAPLACE_SMOOTH) {
						Left= 0;
            for(i=0; i < cav.size(); i++) {
              int c= cav[i];
              Left+= Card * (AT->ClassDistribution[c] + 1) / double(Card + classes);
            }
            Right= 0;
            for(i=0; i < cbv.size(); i++) {
              int c= cbv[i];
              Right+= Card * (AT->ClassDistribution[c] + 1) / double(Card + classes);
            }

            Pair.push_back(Left);
            Pair.push_back(Right);
          }
          else { // ROC_WITH_TRAIN_SMOOTH_AS_ENABLED_FOR_FREQUENCY
            if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_SMOOTHING) {
						  Left= 0;
              for(i=0; i < cav.size(); i++) {
                int c= cav[i];
                Left+= AT->SmoothDistribution[c] * (double)AT->Cardinality;
              }
              Right= 0;
              for(i=0; i < cbv.size(); i++) {
                int c= cbv[i];
                Right+= AT->SmoothDistribution[c] * (double)AT->Cardinality;
              }

              Pair.push_back(Left);
              Pair.push_back(Right);
            }
            else if (Options.ProbabilityInSplittingCriteria == FROM_FREQUENCY_NO_SMOOTHING) {
              Left= 0;
              for(i=0; i < cav.size(); i++) {
                int c= cav[i];
                Left+= AT->ClassDistribution[c];
              }
              Right= 0;
              for(i=0; i < cbv.size(); i++) {
                int c= cbv[i];
                Right+= AT->ClassDistribution[c];
              }

              Pair.push_back(Left);
              Pair.push_back(Right);
            }
          }
        }

        /*
   	 		if ((Pair[0]+Pair[1])>0)
	 			*/ 	solucioROC.push_back(Pair);
	   		/* else {
	   		  solucioROC.push_back(Pair);  // ARA JA ES POT FER A PERQU COMPARA_RATIO VA B
	   		  // eliminats++;   //hem de tindre atenci als nodes amb 0,0 , no els copiem
	   		}
	   		*/
	   		
      }
      else {
        if (solucio[i]->TestDistribution.size() == 0) { // Nodes with no test examples under them are NOT INITIALISED
	   	    vector<double> Pair;
          Pair.push_back(0);
          Pair.push_back(0);	
      	  solucioROC.push_back(Pair);  // ARA JA ES POT FER A PERQU COMPARA_RATIO VA B     	
	   		  // eliminats++;   //hem de tindre atenci als nodes amb 0,0 , no els copiem
        }
        else {
          unsigned int j;
          Left= 0;
          for(j=0; j < cav.size(); j++) {
            int c= cav[j];
            Left+= solucio[i]->TestDistribution[c];
          }
          Right= 0;
          for(j=0; j < cbv.size(); j++) {
            int c= cbv[j];
            Right+= solucio[i]->TestDistribution[c];
          }
          if ((Left + Right)>0) {
	  				vector<double> Pair;
            Pair.push_back(Left);
            Pair.push_back(Right);
				  	solucioROC.push_back(Pair);
					}
	   	    else {
	   	      vector<double> Pair;
            Pair.push_back(0);
            Pair.push_back(0);	
      	    solucioROC.push_back(Pair);  // ARA JA ES POT FER A PERQU COMPARA_RATIO VA B     	
	   		    // eliminats++;   //hem de tindre atenci als nodes amb 0,0 , no els copiem
	   		  }
	   		}
      }
  }

//  cout << "Nodes with 0 examples eliminated: " << eliminats << endl;
  nodes=nodes-eliminats;// hem eliminat nodes
}







// computa A per l'AUC per la formula de Hand vore el seu paper A simple generalisation...
//
double compute_A_Hand(const vector<and_tree *> &solucio, int Roc_With, const options & Options,int ci,int cj, int classes, int nodes)
{
 /* if (classes != 2)
    cout << "iep" ;
  */

  int Roc_Smooth;

  if (Roc_With == ROC_WITH_TRAIN) {   // USE FOR SPLITTING CRITERION (construction of the multitree)
    if (Options.SmoothingInAUCH == AUCH_NO_SMOOTH) {
      Roc_Smooth= ROC_WITH_TRAIN_NO_SMOOTH;
    }
    else if (Options.SmoothingInAUCH == AUCH_M_SMOOTH) {
      Roc_Smooth= ROC_WITH_TRAIN_M_SMOOTH;
    }
    else if (Options.SmoothingInAUCH == AUCH_LAPLACE_SMOOTH) {
      Roc_Smooth= ROC_WITH_TRAIN_LAPLACE_SMOOTH;
    }
    else if (Options.SmoothingInAUCH == AUCH_MBRANCH_SMOOTH) {
      Roc_Smooth= ROC_WITH_TRAIN_MBRANCH_SMOOTH;
    }


 //   Roc_Smooth= ROC_WITH_TRAIN_NO_SMOOTH;  // NO_SMOOTH IF USED AS SPLITTING CRITERION

  }
  else { // (Roc_With == ROC_WITH_TRAIN_ORDER_TEST_FILL)    // USE FOR EVALUATION (AUC measure)
    if (Options.SmoothingInAUCH == AUCH_NO_SMOOTH) {
      Roc_Smooth= ROC_WITH_TRAIN_NO_SMOOTH;
    }
    else if (Options.SmoothingInAUCH == AUCH_M_SMOOTH) {
      Roc_Smooth= ROC_WITH_TRAIN_M_SMOOTH;
    }
    else if (Options.SmoothingInAUCH == AUCH_LAPLACE_SMOOTH) {
      Roc_Smooth= ROC_WITH_TRAIN_LAPLACE_SMOOTH;
    }
    else if (Options.SmoothingInAUCH == AUCH_MBRANCH_SMOOTH) {
      Roc_Smooth= ROC_WITH_TRAIN_MBRANCH_SMOOTH;                 // This is the best
    }
  }	

// int *vectori =(int*) calloc(classes,sizeof(int));
  vector<vector<double> > solucioROC;

  obtain_node_distribution_2class(solucio, Roc_With, Roc_Smooth, Options, solucioROC,ci,cj,classes,nodes );



    if (Roc_With == ROC_WITH_TRAIN_ORDER_TEST_FILL) {
 	      vector<vector<double> > solucioROCOrderTrain;
 	

        obtain_node_distribution_2class(solucio, ROC_WITH_TRAIN, Roc_Smooth, Options, solucioROCOrderTrain,ci,cj,classes,nodes);

   			
   		  for (int j=0; j < nodes; j++) {
   		    solucioROC[j].push_back(solucioROCOrderTrain[j][0]);
      		solucioROC[j].push_back(solucioROCOrderTrain[j][1]);		
   		  }
    }

/*for (unsigned int k=0;k< solucioROC.size();k++)
 {
		cout<<k<<":"<<solucioROC[k][0]<<","<<solucioROC[k][1]<<","<<solucioROC[k][2]<<","<<solucioROC[k][3]<<","<<endl;
} */

  /*
  vector<indext> st;
    st.push_back(5);
    st.push_back(4);

    solucioROC.push_back(st);
  st.clear();
    st.push_back(6);
    st.push_back(3);
    solucioROC.push_back(st);
  st.clear();
    st.push_back(4);
    st.push_back(3);
    solucioROC.push_back(st);
    */

      if (Roc_With != ROC_WITH_TRAIN_ORDER_TEST_FILL) {
   			sort(solucioROC.begin(), solucioROC.end(),compara_ratio);
   		}
   		else {
   		  // ordena amb el training set ara que estan omplits amb el test" << endl;
   			sort(solucioROC.begin(), solucioROC.end(),compara_ratio2);
   			// THE RESULT IS NOW THE SAME WITH stable_sort than sort
   			
   			
   			// random_shuffle(solucioROC.begin(), solucioROC.end());  // a ho desordenaria. Tendix a donar 0.5
   			
        // compara_ratio2 accedix a [2] i [3] per a ordenar..     		
   		}

			
    int cont=0;
    double Ej=0,Ef=0,Et0=0,Et1=0,aux;
    double RatioAnterior= -1;
    double S0=0,Sp=0,A0;
    double Acc= 0.0;
	  for (cont=nodes-1;cont>=0;cont--)	{
      double RatioActual;
	    if (Roc_With != ROC_WITH_TRAIN_ORDER_TEST_FILL) {
		    RatioActual= compute_ratio(solucioROC[cont][0], solucioROC[cont][1]);
	    }
	    else {  // USES TRAINING ORDER
		    RatioActual= compute_ratio(solucioROC[cont][2], solucioROC[cont][3]);
	    }

	    aux=solucioROC[cont][0]+solucioROC[cont][1];

	    if (fabs(RatioActual - RatioAnterior) > 0.00001) {
      //if (RatioActual != RatioAnterior) {  // THIS ALL STUFF IS TO JOIN NODES WITH SAME RATIO
        Sp=(double)(Ej+Ef)/2.0;
        S0+= Acc * Sp;
        Ej=Ef+1;  // move the first pointer (Ej)
        RatioAnterior= RatioActual;
        Acc= 0;
      }

			Ef+= aux;
		  Acc+= solucioROC[cont][0];
      Et0+= solucioROC[cont][0];
      Et1+= solucioROC[cont][1];
    }

    Sp=(double)(Ej+Ef)/2.0;
    S0+= Acc * Sp;

    if (Et0 == 0) {
      A0= 0;
    }
    else if (Et1 == 0) {
      A0= 1;
    }
    else {
      A0=(S0-(Et0*(Et0+1)/2))/(Et0*Et1);
    }
	
    return A0;

}



 // computa  l'AUC per la formula de Hand vore el seu paper A simple generalisation...
double compute_AUC_by_Hand(const vector<and_tree *> &solucio, int Roc_With, const options & Options) {
  int classes, nodes;
  classes=solucio[0]->ClassDistribution.size();// number of classes
  nodes=solucio.size();// number of nodes
  int j,i;
  double sum=0,AUC;
  double Area;


  for (i=0;i<classes;i++)
   for (j=i+1;j<classes;j++) {
     #ifdef HAND
				Area=compute_A_Hand(solucio,Roc_With,Options,i,j,classes,nodes);
	 			
	 			/*
				if (classes > 2) {
	 			  double Area2=compute_A_Hand(solucio,Roc_With,Options,j,i,classes,nodes);
	 			  if (fabs(Area - Area2) > 0.00001) {
	 			    cout << "Hand was right. There are cases where these two areas are not equal." << endl;
	 			    exit(-1);
	 			  }
          Area= (Area + Area2) / 2.0;
	 			}
	 			*/
	 			
     #else
	     vector<vector<double> > Points;
       compute_ROC_points(solucio, Points, Roc_With, Options,i,j);
       compute_ROC_AREA(Points, Area);
     #endif
     //  cout<<"Area "<<i<<","<<j<<":"<<Area<<endl;
     sum+=Area;
	 }
   AUC=(sum*2)/(double)(classes*(classes-1));
   return AUC;
}





// computa A per l'AUC per la formula de Srinivasan... (EN REALITAT ES DE FAWCETT)
double compute_A_Srinivasan(const vector<and_tree *> &solucio, int Roc_With, const options & Options,int ci, int classes, int nodes)
{
 /* if (classes != 2)
    cout << "iep" ;
  */

	
// int *vectori =(int*) calloc(classes,sizeof(int));
 vector<vector<double> > solucioROC;

  obtain_node_distribution_1vsAll(solucio, Roc_With, ROC_WITH_TRAIN_LAPLACE_SMOOTH, Options, solucioROC,ci,classes,nodes );



    if (Roc_With == ROC_WITH_TRAIN_ORDER_TEST_FILL) {
 	      vector<vector<double> > solucioROCOrderTrain;
 	

        obtain_node_distribution_1vsAll(solucio, ROC_WITH_TRAIN, ROC_WITH_TRAIN_LAPLACE_SMOOTH, Options, solucioROCOrderTrain,ci,classes,nodes);

           			
   		  for (int j=0; j < nodes; j++) {
   		    solucioROC[j].push_back(solucioROCOrderTrain[j][0]);
      		solucioROC[j].push_back(solucioROCOrderTrain[j][1]);		
   		  }
    }
      if (Roc_With != ROC_WITH_TRAIN_ORDER_TEST_FILL) {
   			sort(solucioROC.begin(), solucioROC.end(),compara_ratio);
   		}
   		else {
   		  // ordena amb el training set ara que estan omplits amb el test" << endl;
   			sort(solucioROC.begin(), solucioROC.end(),compara_ratio2);
   			
   			// random_shuffle(solucioROC.begin(), solucioROC.end());  // a ho desordenaria. Tendix a donar 0.5
   			
        // compara_ratio2 accedix a [2] i [3] per a ordenar..     		
   		}

			
   int cont=0;
    double Ej=0,Ef=0,Et0=0,Et1=0,aux;
    double RatioAnterior= -1;
    double S0=0,Sp=0,A0;
    double Acc= 0.0;
	  for (cont=nodes-1;cont>=0;cont--)	{
      double RatioActual;
	    if (Roc_With != ROC_WITH_TRAIN_ORDER_TEST_FILL) {
		    RatioActual= compute_ratio(solucioROC[cont][0], solucioROC[cont][1]);
	    }
	    else {  // USES TRAINING ORDER
		    RatioActual= compute_ratio(solucioROC[cont][2], solucioROC[cont][3]);
	    }

	    aux=solucioROC[cont][0]+solucioROC[cont][1];

	    if (fabs(RatioActual - RatioAnterior) > 0.00001) {	
      // if (RatioActual != RatioAnterior) {
        Sp=(double)(Ej+Ef)/2.0;
        S0+= Acc * Sp;
        Ej=Ef+1;  // move the first pointer (Ej)
        RatioAnterior= RatioActual;
        Acc= 0;
      }

			Ef+= aux;
		  Acc+= solucioROC[cont][0];
      Et0+= solucioROC[cont][0];
      Et1+= solucioROC[cont][1];
    }

    Sp=(double)(Ej+Ef)/2.0;
    S0+= Acc * Sp;

    if (Et0 == 0) {
      A0= 0;
    }
    else if (Et1 == 0) {
      A0= 1;
    }
    else {
      A0=(S0-(Et0*(Et0+1)/2))/(Et0*Et1);
    }	
    return A0;

}




 // computa  l'AUC per la formula de Srinivasan en realitat segons el paper de Fawcett "Using Rule Sets..."...
double compute_AUC_by_Srinivasan(const vector<and_tree *> &solucio, int Roc_With, const options & Options, bool UseProb) {
  int classes, nodes;
  classes=solucio[0]->ClassDistribution.size();// number of classes
  nodes=solucio.size();// number of nodes
  double sum=0;
  double Area;
  vector<double> Prob(classes);
  double Total= 0;

  int i;
  // Computes class probabilities in Prob[]
  for (int j=0;j<nodes;j++) {
    for (i=0;i<classes;i++) {
      double Num= solucio[j]->ClassDistribution[i];
		  Prob[i]+= Num;
		  Total+= Num;
		}
  }
  for (i=0;i<classes;i++) {
	  Prob[i]/= Total;
	}

  // Computes AUC by Srinivasan
  for (i=0;i<classes;i++) {
		Area=compute_A_Srinivasan(solucio,Roc_With,Options,i,classes,nodes);
     //  cout<<"Area "<<i<<","<<j<<":"<<Area<<endl;
    if (UseProb)
      sum+=Area * Prob[i];
	  else
	    sum+=Area * (1.0 / double(classes));	
	}
  return sum;
}




// computa A per l'AUC per la formula meua (partition)
double compute_A_Ploro(const vector<and_tree *> &solucio, int Roc_With, const options & Options,
                       const vector<int> &cav, const vector<int> &cbv, int classes, int nodes) {
 /* if (classes != 2)
    cout << "iep" ;
  */

	
// int *vectori =(int*) calloc(classes,sizeof(int));
  vector<vector<double> > solucioROC;

  obtain_node_distribution_General(solucio, Roc_With, ROC_WITH_TRAIN_LAPLACE_SMOOTH, Options, solucioROC, cav, cbv, classes,nodes );



    if (Roc_With == ROC_WITH_TRAIN_ORDER_TEST_FILL) {
 	      vector<vector<double> > solucioROCOrderTrain;
 	

        obtain_node_distribution_General(solucio, ROC_WITH_TRAIN, ROC_WITH_TRAIN_LAPLACE_SMOOTH, Options, solucioROCOrderTrain,cav, cbv,classes,nodes);

           			
   		  for (int j=0; j < nodes; j++) {
   		    solucioROC[j].push_back(solucioROCOrderTrain[j][0]);
      		solucioROC[j].push_back(solucioROCOrderTrain[j][1]);		
   		  }
    }
      if (Roc_With != ROC_WITH_TRAIN_ORDER_TEST_FILL) {
   			sort(solucioROC.begin(), solucioROC.end(),compara_ratio);
   		}
   		else {
   		  // ordena amb el training set ara que estan omplits amb el test" << endl;
   			sort(solucioROC.begin(), solucioROC.end(),compara_ratio2);
   			
   			// random_shuffle(solucioROC.begin(), solucioROC.end());  // a ho desordenaria. Tendix a donar 0.5
   			
        // compara_ratio2 accedix a [2] i [3] per a ordenar..     		
   		}

			
   int cont=0;
    double Ej=0,Ef=0,Et0=0,Et1=0,aux;
    double RatioAnterior= -1;
    double S0=0,Sp=0,A0;
    double Acc= 0.0;
	  for (cont=nodes-1;cont>=0;cont--)	{
      double RatioActual;
	    if (Roc_With != ROC_WITH_TRAIN_ORDER_TEST_FILL) {
		    RatioActual= compute_ratio(solucioROC[cont][0], solucioROC[cont][1]);
	    }
	    else {  // USES TRAINING ORDER
		    RatioActual= compute_ratio(solucioROC[cont][2], solucioROC[cont][3]);
	    }

	    aux=solucioROC[cont][0]+solucioROC[cont][1];

	    if (fabs(RatioActual - RatioAnterior) > 0.00001) {	
      // if (RatioActual != RatioAnterior) {
        Sp=(double)(Ej+Ef)/2.0;
        S0+= Acc * Sp;
        Ej=Ef+1;  // move the first pointer (Ej)
        RatioAnterior= RatioActual;
        Acc= 0;
      }

			Ef+= aux;
		  Acc+= solucioROC[cont][0];
      Et0+= solucioROC[cont][0];
      Et1+= solucioROC[cont][1];
    }

    Sp=(double)(Ej+Ef)/2.0;
    S0+= Acc * Sp;

    if (Et0 == 0) {
      A0= 0;
    }
    else if (Et1 == 0) {
      A0= 1;
    }
    else {
      A0=(S0-(Et0*(Et0+1)/2))/(Et0*Et1);
    }	
    return A0;

}

// makes the next partition of classes
// returns true if there are more partitions and false if this one was the last one
bool Next(vector<int> &cav, vector<int> &cbv, int classes) {
  int SizeLeft= cav.size();
  int SizeRight= cbv.size();

  int i, j;

  bool More= true;

  for (i=(SizeLeft-1); i>=0; i--) {
    if (cav[i] == (classes - (SizeLeft - i))) {
      int j=i;
      while (cav[j] == (classes - (SizeLeft - j))) {
        j--;
      }
      cav[j]++;
      j++;
      for (; j<SizeLeft; j++) {
        cav[j]= cav[j-1]+1;
      }
      break;
    }
    else {
      cav[i]++;
      break;
    }
  }

  // And now just put the rest on cbv.
  i=0;
  int k;
  for (k=0; k<classes; k++) {
    bool Used= false;

    int j;
    for (j=0; j<SizeLeft; j++) {
      if (k == cav[j]) {
        Used= true;
        break;
      }
    }
    if (!Used) {
      cbv[i]= k;
      i++;
      if (i == SizeRight)
        break;
    }
  }

  if (k == SizeRight - 1) {  // we have used exactly the first k classes for the right. That means we have exhausted the combinations.
    More=false;
  }



  return More;
}


 // computa  l'AUC per la formula meua (PARTITION)
 double compute_AUC_by_Ploro(const vector<and_tree *> &solucio, int Roc_With, const options & Options, bool UseProb) {
  int classes, nodes;
  classes=solucio[0]->ClassDistribution.size();// number of classes
  nodes=solucio.size();// number of nodes
  double sum=0;
  double Area;
  vector<double> Prob(classes);
  double Total= 0;

  int i;
/*
  // Computes class probabilities in Prob[]
  for (int j=0;j<nodes;j++) {
    for (i=0;i<classes;i++) {
      double Num= solucio[j]->ClassDistribution[i];
		  Prob[i]+= Num;
		  Total+= Num;
		}
  }
  for (i=0;i<classes;i++) {
	  Prob[i]/= Total;
	}
*/

  // Computes AUC by PLORO

  // Partition the classes (half and half). If odd, the left part has one more than the right part
  int SizeLeft= classes / 2 + classes % 2;
  int SizeRight= classes / 2;
  vector<int> cav(SizeLeft);
  vector<int> cbv(SizeRight);
  for (i=0;i<SizeLeft;i++) {
    cav[i]= i;
  }
  for (i=0;i<SizeRight;i++) {
    cbv[i] = SizeLeft + i;
  }

  bool more;
  double nAreas= 0;
  do {
	  Area=compute_A_Ploro(solucio, Roc_With,Options, cav, cbv, classes, nodes);

     //  cout<<"Area "<<i<<","<<j<<":"<<Area<<endl;
/*    if (UseProb)
      sum+=Area * Prob[i];
	  else
*/
    sum+=Area;	// binary partition

	  nAreas++;
	
    if (more)
      more= Next(cav, cbv, classes);
    else
      break;
  }
  while(true);

  sum/= nAreas;

  return sum;
}

void   Compute_Some_Sample_Points_ROC_By_Programa() // function just to compute areas of roc by hand. Ignore this function

{

    vector<vector<double> > punts;

    vector<double> V(2);
    V[0]= 0; V[1]= 0;
    punts.push_back(V);
    V[0]= 1.0/190.0; V[1]= 18.0/120.0;
    punts.push_back(V);
    V[0]= 11.0/190.0; V[1]= 98.0/120.0;
    punts.push_back(V);

    V[0]= 101.0/190.0; V[1]= 118.0/120.0;
    punts.push_back(V);

    V[0]= 140.0/190.0; V[1]= 120.0/120.0;
    punts.push_back(V);


    V[0]= 1; V[1]= 1;
    punts.push_back(V);

	 	for(unsigned long i1=0; i1 < punts.size(); i1++) {
	          for(unsigned long j1=0; j1 < punts[i1].size(); j1++)
	  		      cout << punts[i1][j1] << " ";
	  		    cout<<endl;
	  }
	
	  double Area;
	  compute_ROC_AREA(punts, Area);
	  cout << "Area Under the ROC Curve: " << Area << endl;
	
}


  // This function is used as a < for calling Rank.Sort in the function Evaluate
  bool CompareRanks(rank o1, rank o2)  {
    if (o1.Rank < o2.Rank)
      return true;
    else
      return false;
  }	





// AUC Calculation using RankVector
double Compute_AUC_by_Ranks(vector<rank> &RankVector, unsigned long Card, unsigned int i, unsigned int j) {

   unsigned long HitsClassI= 0, HitsClassJ= 0;
   unsigned long k;
   for(k=0; k < Card; k++) {
     double Den= RankVector[k].ClassProbVector[i] + RankVector[k].ClassProbVector[j];
     if (Den) {
       RankVector[k].Rank = RankVector[k].ClassProbVector[i] / Den;
     }
     else
       RankVector[k].Rank= 0.5;

     if (RankVector[k].Real == i)
       HitsClassI++;
     if (RankVector[k].Real == j)
       HitsClassJ++;
   }


   sort(RankVector.begin(), RankVector.end(), CompareRanks);  // ordena pel rank
    // stable_sort is slower than sort but preserves the original order when two or more elements have the same value.
    // it is the same to use one or the other. So, we use sort that is quicker.


/*
    double S0b= 0.0;

    // Computed in Hand's way
    for(k=0; k < Card; k++) {
      if (RankVector[k].Real == i)
        S0b+= k+1;  // ranks go from 1 to n, not from from 0 to n-1
    }
*/

/*
    // PROVA A M PER A COMPROVAR QUE VA B.
    Card= 25;
    vector<rank> v2(25);
    RankVector= v2;
    Hits= 15;
    RankVector[0].Reliability= 0.1;
    RankVector[0].Correct= true;
    RankVector[1].Reliability= 0.1;
    RankVector[1].Correct= true;
    RankVector[2].Reliability= 0.1;
    RankVector[2].Correct= true;
    RankVector[3].Reliability= 0.1;
    RankVector[3].Correct= true;
    RankVector[4].Reliability= 0.1;
    RankVector[4].Correct= true;
    RankVector[5].Reliability= 0.1;
    RankVector[5].Correct= false;
    RankVector[6].Reliability= 0.1;
    RankVector[6].Correct= false;
    RankVector[7].Reliability= 0.1;
    RankVector[7].Correct= false;
    RankVector[8].Reliability= 0.1;
    RankVector[8].Correct= false;
    RankVector[9].Reliability= 0.2;
    RankVector[9].Correct= true;
    RankVector[10].Reliability= 0.2;
    RankVector[10].Correct= true;
    RankVector[11].Reliability= 0.2;
    RankVector[11].Correct= true;
    RankVector[12].Reliability= 0.2;
    RankVector[12].Correct= true;
    RankVector[13].Reliability= 0.2;
    RankVector[13].Correct= true;
    RankVector[14].Reliability= 0.2;
    RankVector[14].Correct= true;
    RankVector[15].Reliability= 0.2;
    RankVector[15].Correct= false;
    RankVector[16].Reliability= 0.2;
    RankVector[16].Correct= false;
    RankVector[17].Reliability= 0.2;
    RankVector[17].Correct= false;
    RankVector[18].Reliability= 0.3;
    RankVector[18].Correct= true;
    RankVector[19].Reliability= 0.3;
    RankVector[19].Correct= true;
    RankVector[20].Reliability= 0.3;
    RankVector[20].Correct= true;
    RankVector[21].Reliability= 0.3;
    RankVector[21].Correct= true;
    RankVector[22].Reliability= 0.3;
    RankVector[22].Correct= false;
    RankVector[23].Reliability= 0.3;
    RankVector[23].Correct= false;
    RankVector[24].Reliability= 0.3;
    RankVector[24].Correct= false;

    // Este exemple ha de donar 197 d'A0 i 0.513 d'area
*/


    double S0= 0.0;
    // Computed using means
    float PrevRel= -1;
    long First= 0, Acc= 0;
    unsigned long r= 0;   // r is the real rank
    for(k=0; k < Card; k++) {
      if (fabs(PrevRel - RankVector[k].Rank) > 0.00001) {
 //     if (PrevRel != RankVector[k].Rank) {
        double Mean= (First + r) / 2.0; // Mean of all the ranks with same reliability
        S0+= Acc * Mean;
        First= r+1; // ranks go from 1 to n, not from from 0 to n-1
        Acc= 0;
        PrevRel= RankVector[k].Rank;
      }
      if (RankVector[k].Real == i) {
        Acc++;
        r++;  // ONLY IF IS ONE OF THE TWO CLASSES WE'RE CONSIDEREING WE INCREMENT THE RANK
      }
      else if (RankVector[k].Real == j) {
        r++; // ONLY IF IS ONE OF THE TWO CLASSES WE'RE CONSIDEREING WE INCREMENT THE RANK
      }
    }
    S0+= Acc * (First + r) / 2.0;

   // S0= S0b;

    double Area;

    if (HitsClassI == 0)
      Area= 0;
    else if (HitsClassJ == 0)
      Area= 1;
    else {
      Area= S0 - HitsClassI * (HitsClassI + 1) / 2.0;
      Area/= HitsClassI * HitsClassJ;
    }

  return Area;
}

