/***************************************************************************
                          temps.cpp  -  description
                             -------------------

    functionality        : utilities for handling time
    relevant classes     :
    relevant functions   : start_st, stop_st, pulsos_a_segs, vore_st

    begin                : 20 Oct 2001
    copyright            : (C) 2001 by Cesar Ferri, Jose Hernandez
    email                : {cferri,jorallo}@dsic.upv.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


/*************** ESTADISTICAS Y CALCULOS DE EFICIENCIA ****************/

#include <ctime>
#include <iostream>

using namespace std; // this is necessary for some compilers.


time_t T1;

void start_st()
{ 	
	T1=clock();
}


void stop_st()
{
	T1=clock()-T1;
}


float pulsos_a_segs(time_t pulsos)
{ /* Pasa los pulsos a segundos; maximo dos decimales.
	Como C solo tiene division entera hay que hallar los
	decimales a "mano". */
	
	float segs; /* Segundos que se retornaran */
	unsigned long int c0, c1, c2; /* Cocientes */
	unsigned long int r1, r2; /* Restos */
	c0 = pulsos / CLOCKS_PER_SEC; /* parte entera */
	r1 = pulsos % (long)CLOCKS_PER_SEC;
	c1 = (r1 * 10) / CLOCKS_PER_SEC; /* Primer decimal */
	r2 = (r1 * 10) % (long)CLOCKS_PER_SEC;
	c2 = (r2 * 10) / CLOCKS_PER_SEC; /* Segundo decimal */
	segs = c0 + (0.1 * c1) + (0.01 * c2);
	return (segs);
}


void vore_st(const char *Cad)
{
  float segs;

 segs = pulsos_a_segs(T1);

 cout << Cad << segs << " secs. \n";

}

float donam_st()
{
  return pulsos_a_segs(T1);
}

